var ec = new ECommerceInterface ();  // only create one per page

var debug = false;
var wii = true;
var opera = true; // set by vcInitPage()
var msie = false; // set by vcInitPage()

var opName;
var opDesc;
var htmlPath = "../html/";
var imagesPath = "../images";
var manual = "manual/index/index_Frameset.html";
var ossPath = "";
var secureOssPath = "";
var ecTimeout = null;
var ecProgressInterval = 1000; // Timeout for checking progress in milliseconds

function ECTimeout(timeout, interval)
{
    this.timeout = timeout; // Timeout in milliseconds (to cancel)
    this.noProgressMillis = 0; // Milliseconds for which no progress was made
    this.lastPhase = 0; // Last progress phase
    this.lastDownloadedSize = 0; // Last downloaded size
}

function ecSupportsSession()
{
    return ("setSessionValue" in ec && "getSessionValue" in ec);
}

function showOldPage(page)
{
    var url = null;
    if (ecSupportsSession()) {
    	url = ec.getSessionValue("history." + page);
    } 
    if (url != null) {
        trace("ShowOldPage: going to " + url);
    	top.location=url;
    } else {
    	showPage(page);
    }
}

function doPost(url, params)
{
    //trace("doPost(" + url + ", " + params + ")");
    if (url != null && params != null) {
	var form;
        form = document.getElementById("PostForm");
        if (form == null) {
            form = document.createElement("form");
            form.action = url;
            form.method = "post";
            form.id="PostForm";
            document.body.appendChild(form);
        }
    
        var formHTML = "";
        var paramArray = params.split("&");
        var i;
        for (i in paramArray) {
            var param = paramArray[i];
            var index = param.indexOf("=");
            if (index >= 0) {
            	var name = param.substr(0, index);
            	var value = param.substr(index+1);
            	if (name == "token") {
		    value = ec.getWeakToken ();
		}
	        formHTML += '<input type="hidden" name="' + name + '" value="' + value + '"/>';
	    }
	}
	formHTML += '<div id="post.commonFields"></div>';
        form.innerHTML = formHTML;
        initCommonFields("post.commonFields");
     
        form.submit();
    }
}

function updateHistory()
{
    if (ecSupportsSession() && top == self) {
    	var method = getMethod();
        var currUrl = location.href;
        var currPath = location.pathname;
        var currSearch = location.search;
        var page = currPath;
        var i = currPath.lastIndexOf("/");
        if (i >= 0) {
            page = currPath.substr(i+1);
        }
        trace("currPath is " + currPath);
	
	if (method == "POST") {
	    var params = getPostParams();
	    var secureUrl = getSecureUrl(page);
	    currUrl = "javascript:doPost('" + secureUrl + "','" + params + "')";
	}
	
        var currPage = "history." + page;
        var lastPage = ec.getSessionValue("history.0");
        ec.setSessionValue(currPage, currUrl);

        if (currPage == lastPage) {
            return;
        }
        ec.setSessionValue("history.-1", lastPage);
        ec.setSessionValue("history.0", currPage);
        //trace("lastPage is " + lastPage);
        //trace("currPage is " + currPage);
        //trace("currUrl is " + currUrl);
        
        // Hack for page B_04's showBack
        if (page.indexOf("B_03") == 0 || page.indexOf("B_01") == 0) {
            ec.setSessionValue("history.B_04.-1", currPage);
        } else if (page.indexOf("B_04") == 0) {
            var B_04Last = ec.getSessionValue("history.B_04.-1");
            if (B_04Last != null) {
                ec.setSessionValue("history.-1", B_04Last);
            }
        }
        
        // Hack for page B_05's showBack
        if (page.indexOf("W_01") == 0 || page.indexOf("B_04") == 0 || page.indexOf("H_01") == 0) {
            ec.setSessionValue("history.B_05.-1", currPage);
        } else if (page.indexOf("B_05") == 0) {
            var B_05Last = ec.getSessionValue("history.B_05.-1");
            if (B_05Last != null) {
                ec.setSessionValue("history.-1", B_05Last);
            }
        }

        // Hack for page B_09's showBack
        if (page.indexOf("W_01") == 0 || page.indexOf("B_04") == 0 || page.indexOf("H_01") == 0) {
            ec.setSessionValue("history.B_09.-1", currPage);
        } else if (page.indexOf("B_09") == 0) {
            var B_09Last = ec.getSessionValue("history.B_09.-1");
            if (B_09Last != null) {
                ec.setSessionValue("history.-1", B_09Last);
            }
        }
    }
}

function isHRPDisablePage()
{
    if (isConnectingPage()) {
    	return true;
    }

    var currPath = location.pathname;
    var page = currPath;
    var i = currPath.lastIndexOf("/");
    if (i >= 0) {
        page = currPath.substr(i+1);
    }

    if (page.indexOf("B_09") == 0 || page.indexOf("B_10") == 0
        || page.indexOf("S_09") == 0 || page.indexOf("S_10") == 0
        || page.indexOf("S_02") == 0 || page.indexOf("S_06") == 0) {
    	return true;
    } else {
    	return false;
    }
}

function cancel()
{
    ec.cancelOperation();
}

function showBack(index)
{
    var lastUrl = null;
    if (ecSupportsSession()) {
    	var lastPage;
    	if (index != null) {
    	    lastPage = ec.getSessionValue("history." + index);
    	} else {
    	    lastPage = ec.getSessionValue("history.-1");
    	}
    	if (lastPage != null) {
    	    lastUrl = ec.getSessionValue(lastPage);
    	}
    } 
    if (lastUrl != null) {
        trace("showBack: last url was " + lastUrl);
    	top.location=lastUrl;
    } else {
    	history.back();
    }
}

function addParam(url, param, value)
{
    var setParamStr = param + "=" + value;
    if (url.indexOf("?" + param + "=") >= 0 || 
        url.indexOf("&" + param + "=") >= 0) {
        // param already in url
    } else {
        var paramStart = url.indexOf("?");
        if (paramStart >= 0) {
            url = url.substr(0, paramStart+1) + setParamStr + "&" + url.substr(paramStart+1);
        } else {
            url = url + "?" + setParamStr;
        }
    }
    return url;
}

function addCommonParams(url, includeDeviceParams)
{
    var r = ec.getDeviceInfo ();
    var newUrl = url;
    if (typeof(r) == "object") {
        if (r.country != null) {
            newUrl = addParam(newUrl, "country", r.country);
        }
        if (r.region != null) {
            newUrl = addParam(newUrl, "region", r.region);
        }
        trace("isParentalControlEnabled: " + r.isParentalControlEnabled + ", age: " + r.userAge);
        if (r.userAge != null && r.isParentalControlEnabled) {
            newUrl = addParam(newUrl, "age", r.userAge);
        }
        if (r.language != null) {
            newUrl = addParam(newUrl, "language", r.language);
        }
        
        if (includeDeviceParams) {
            if (r.accountId != null) {
                newUrl = addParam(newUrl, "accountId", r.accountId);
            }
            if (r.deviceId != null) {
                newUrl = addParam(newUrl, "deviceId", r.deviceId);
            }
            if (r.serial != null) {
                newUrl = addParam(newUrl, "serialNo", r.serial);
            }
        }
   }
   return newUrl;
}

function removeSessionId(url)
{
    url = url.replace(/;jsessionid=(.*)\?/, "?");
    return url;
}

function isRelativePath(url)
{
    return (url.indexOf("javascript:") != 0 && 
            url.indexOf("http:") != 0 && 
            url.indexOf("https:") != 0);
}

function showSecurePage(url, replace) {
    showPage(url, replace, true);
}

function showPage(url, replace, secure) {
    // Currently sessions are not used 
    // Keep session id if we need to use sessions
    url = removeSessionId(url);
    if (url.indexOf("javascript:") != 0) {
        url = url.replace("&amp;", "&");
        url = addCommonParams(url);     
    }
    if (isRelativePath(url)) {
    	if (secure) {
    	    // Make sure to use secure url
    	    url = secureOssPath + url;
    	} else {
	    // Make sure to use non-secure url
       	    url = ossPath + url;
       	}    
    }    
    trace("showPage: going to page " + url);
    if (replace) {
        location.replace(url);
    } else {
        top.location=url;
    }
}

function replacePage(url)
{
    //showPage(url, true);
    location.replace(url);
}

function showHelp(index)
{
    // Redirect to different help file
    var url = htmlPath + manual;
    top.location=url;
}

function showWelcome(replace) {
    showCheckBalance("W_01.jsp");
}

function showHome(replace) {
    showPage("W_03.jsp", replace);
}

function showPoints() 
{
    showPage("P_01.jsp");
}

function showVC()
{
    showPage("B_01.jsp");
}

function showSettings()
{
    showPage("S_01.jsp");
}

function showOwnedTitles() {
    trace("showOwnedTitles");
    // TODO: Use HTTPS
    var form;
    form = document.getElementById("ListOwnedTItlesForm");
    if (form == null) {
        form = document.createElement("form");
        form.action = getSecureUrl("B_04.jsp");
        form.method = "post";
        form.id="ListOwnedTItlesForm";
        document.body.appendChild(form);
    }
    
    var formHTML = "";
    formHTML += '<div id="B_04.commonFields"></div>';
    formHTML += '<div id="ownedTitles"></div>';
    form.innerHTML = formHTML;
    initCommonFields("B_04.commonFields");
 
    var nTitles = 0;
    var titles = ec.getTitleInfos ();
    if (typeof(titles) == "object") {
        var inputHTML = "";
    	trace("Number of owned titles (unfiltered): " + titles.length);
        for (i = 0;  i < titles.length;  ++i) {
            var t = titles.get(i);
            trace("Title is " + t.titleId);
            // Filter out titles without shopping channel id (00010001)
            if (t != null && t.titleId != null &&
                t.titleId.substr(0, 8) == '00010001') {
                nTitles++;
                inputHTML += '<input type="hidden" name="titleId" value="' + escape(t.titleId) + '"/>';
            } 
        }
        document.getElementById("ownedTitles").innerHTML = inputHTML;
    }

    trace("Number of owned titles: " + nTitles);
    if (nTitles > 0) {
       form.submit();
    } else {
       showPage('B_04_2.jsp');
    }
}

function showTransactions(page) {
    trace("showTransactions");
    // TODO: Use HTTPS
    var form;
    var url = "H_01.jsp"
    form = document.getElementById("ListTransForm");
    if (form == null) {
        form = document.createElement("form");        
        form.action = getSecureUrl(url);
        form.method = "post";
        form.id="ListTransForm";
        document.body.appendChild(form);
    } 
    var formHTML = "";
    formHTML += '<div id="H_01.commonFields"></div>';
    if (page != null) {
        formHTML += '<input type="hidden" name="p" value="' + escape(page) + '"/>';
    }
    var weakToken = ec.getWeakToken ();
    if (weakToken != null) {
        formHTML += '<input type="hidden" name="token" value="' + escape(weakToken) + '"/>';
    }
    form.innerHTML = formHTML;
    initCommonFields("H_01.commonFields");

    form.submit();
}

function showReceipt(transactionId, transactionCountry) {
    trace("showReceipt");
    // TODO: Use HTTPS
    var form;
    form = document.getElementById("ReceiptForm");
    if (form == null) {
        form = document.createElement("form");
        form.action = getSecureUrl("H_02.jsp");
        form.method = "post";
        form.id="ReceiptForm";
        document.body.appendChild(form);
    } 
    var formHTML = "";
    formHTML += '<div id="H_02.commonFields"></div>';
    var weakToken = ec.getWeakToken ();
    if (weakToken != null) {
        formHTML += '<input type="hidden" name="token" value="' + escape(weakToken) + '"/>';
    }
    formHTML += '<input type="hidden" name="transId" value="' + escape(transactionId) + '"/>';
    formHTML += '<input type="hidden" name="transCountry" value="' + escape(transactionCountry) + '"/>';
    form.innerHTML = formHTML;        
    initCommonFields("H_02.commonFields");
    form.submit();
}

function showCheckBalance(next)
{
    trace("showCheckBalance " + next);
    // TODO: Use HTTPS
    var form;
    form = document.getElementById("CheckBalanceForm");
    if (form == null) {
        form = document.createElement("form");
        form.action = getSecureUrl("CheckBalance.jsp");
        form.method = "post";
        form.id="CheckBalanceForm";
        document.body.appendChild(form);
    } 
    
    var formHTML = "";
    formHTML += '<div id="CheckBalance.commonFields"></div>';
    if (next != null) {
        formHTML += '<input type="hidden" name="next" value="' + escape(next) + '"/>';
    }
    form.innerHTML = formHTML;
    initCommonFields("CheckBalance.commonFields");
    
    form.submit();
}

function isConnectingToServer()
{
    if (ecSupportsSession()) {
        var connecting = ec.getSessionValue("connecting"); 
        if (connecting == "true") {
           return true;
        }
    }
    
    return false;    
}

function setConnectingToServer(connecting)
{
    if (ecSupportsSession()) {
        if (connecting) {
            ec.setSessionValue("connecting", "true");            
            wiiStartWaiting();
        } else {
            ec.setSessionValue("connecting", "false");
            wiiStopWaiting();
        }
    }
}

function isCheckRegisterNeeded()
{
    if (ecSupportsSession()) {
        var accountInvalid = ec.getSessionValue("accountInvalid"); 
        if (accountInvalid == "true") {
           return true;
        }
    }
    
    return false;    
}

function setCheckRegisterNeeded(checkNeeded)
{
    if (ecSupportsSession()) {
        if (checkNeeded) {
            ec.setSessionValue("accountInvalid", "true");            
        } else {
            ec.setSessionValue("accountInvalid", "false");
        }
    }
}

function getShopAppTitleId()
{
    var r = ec.getDeviceInfo();
    var shopAppTitleId = null;
    if (typeof(r) == "object") {
        shopAppTitleId = r.titleId;
    }
    return shopAppTitleId;
}

function showCheckRegistered(forceCheck)
{
    trace("showCheckRegistered " + forceCheck);
    // Redirects to CheckRegistered.jsp with important device info	
    var url = "/CheckRegistered.html";
    var r = ec.getDeviceInfo();
    var shopAppTitleId = getShopAppTitleId();
    if (shopAppTitleId != null) {
        url = url + "?titleId=" + shopAppTitleId;
    }
    
    if (forceCheck) {
        setCheckRegisterNeeded(true);
    }
    
    replacePage(url);
}

function showRegister(memberId, password, next)
{
    trace("showRegister");
    // Use HTTPS
    var form;
    form = document.getElementById("RegisterForm");
    if (form == null) {
        form = document.createElement("form");
        form.action = getSecureUrl("Register.jsp");
        form.method = "post";
        form.id="RegisterForm";
        document.body.appendChild(form);
    } 

    var formHTML = "";
    formHTML += '<div id="Register.commonFields"></div>';
    if (memberId != null) {
        formHTML += '<input type="hidden" name="loyaltyMemberId" value="' + escape(memberId) + '"/>';
    }
    if (password != null) {
        formHTML += '<input type="hidden" name="loyaltyPassword" value="' + escape(password) + '"/>';
    }
    if (next != null) {
        formHTML += '<input type="hidden" name="next" value="' + escape(next) + '"/>';
    }
    form.innerHTML = formHTML;
    initCommonFields("Register.commonFields");

    form.submit();
}

function doUnregister()
{
    trace("doUnregister");
    // Use HTTPS
    var form;
    form = document.getElementById("UnregisterForm");
    if (form == null) {
        form = document.createElement("form");
        form.action = getSecureUrl("S_10.jsp");
        form.method = "post";
        form.id="UnregisterForm";
        document.body.appendChild(form);
    }
    
    var formHTML = "";
    formHTML += '<div id="S_10.commonFields"></div>';
    form.innerHTML = formHTML;
    initCommonFields("S_10.commonFields");
     
    form.submit();
}

function showWiiMenu()
{
    if (wii) {
        shop.returnToMenu();
    } else {
        showPage("TestSettings.jsp");
    }   
}

// Default onOpDone
//
function checkProgress(firstTime, operation, description, onDone)
{
    var progress = ec.getProgress();

    currBalance = document.getElementById("currentBalance");
    if(currBalance) {
	currBalance.innerHTML = getBalance();
    }
                
    if (progress.status == EC_ERROR_NOT_BUSY) {
    	return;
    }

    if (progress.status == EC_ERROR_NOT_DONE) {    
        if (ecTimeout != null) {
            //trace(operation + " using timeout " + ecTimeout.timeout);
            //trace(operation + " total size " + progress.totalSize);
            //trace(operation + " downloaded size " + progress.downloadedSize + " last " + ecTimeout.lastDownloadedSize);
            //trace(operation + " phase " + progress.phase + " last " + ecTimeout.lastPhase);
            //trace(operation + " no progress millis " + ecTimeout.noProgressMillis);
            if (firstTime) {
                ecTimeout.noProgressMillis = 0;
                ecTimeout.lastDownloadedSize = 0;
                ecTimeout.phase = progress.phase;
            } else {
                var hasProgress = false;
       	        if (progress.totalSize) {
	            // There is a totalSize - see if progress was made
	            hasProgress = (progress.downloadedSize != ecTimeout.lastDownloadedSize);
  	        } else {
  	            hasProgress = (progress.phase != ecTimeout.lastPhase);
	        }
	        
	        if (hasProgress) {
	            ecTimeout.noProgressMillis = 0;
	            ecTimeout.lastDownloadedSize = progress.downloadedSize;
	            ecTimeout.lastPhase = progress.phase;
	        } else {
	            ecTimeout.noProgressMillis += ecProgressInterval;
	        }
	    
                // Don't have timeout for syncetickets (syncing one eticket may take up to 5 seconds)
                if (progress.phase != EC_PHASE_GettingTicketsFromServer) {
		    if (ecTimeout.noProgressMillis >= ecTimeout.timeout) {
                    	trace(operation + " has timed out: canceling");
                    	ec.cancelOperation();
                    }
                }
            }        
        }
  	setTimeout ('checkProgress(false,"' + operation + '","' + description
                    + '","' + onDone + '")', ecProgressInterval);
    } else if (progress.status == EC_ERROR_CANCEL_FAILED) {
       trace(operation + " cancel failed");
       var ossErrorCode = getOssErrorCode(progress);
       wiiStopWaiting();
       wiiEnableHRP();
       wiiShowError(ossErrorCode, cET_Server);
    } else {
        eval (onDone+"(progress)");
    }
}

function  onOpDone (progress)
{
    showResult (progress, opName, opDesc);
}


function showResult (progress, operation, description)
{
    if (debug) {
        showProgressResult(progress, operation, description);        
    } 
    trace(operation + " got progress status " + progress.status + ", errCode " + progress.errCode);
    var errDetail = getErrorDetail(progress.status, progress.errCode, progress.errInfo);
    if (errDetail != null) {
        trace(operation + ":" + errDetail);
    }
    if (!isConnectingToServer()) {
        wiiStopWaiting();
    }   
    wiiEnableHRP();
}

function finishOp(opName, opDesc, progress, doneFunc)
{
    trace("Doing op " + opName);
    if ( wasOpStarted (progress, opDesc)) {    	
        if (debug) {
            showProgress(true, opName, opDesc, doneFunc);
        } else {
            checkProgress(true, opName, opDesc, doneFunc);
        }
        
        if (!isConnectingToServer()) {
            wiiStartWaiting();
        }
    } else {
	eval(doneFunc+"(progress)");
    }            
}

function getPointsBalance(doneFunc)
{
    var progress = ec.refreshCachedBalance ();

    opName = "Refresh Points Balance";
    opDesc = "Refreshing Points available for purchases";
    finishOp(opName, opDesc, progress, doneFunc);
}
        
function register(challenge, memberId, password)
{
    if (memberId != null) {
        memberId.replace(/^\s+|\s+$/, '');
        password = (memberId == '') ? '' : password;
    }
    var progress = ec.register(challenge, memberId, password);
 
    opName = "Register";
    opDesc = "Registering";
    finishOp(opName, opDesc, progress, "onRegisterDone");
}

function getRegistrationInfo(challenge)
{
    var progress = ec.register(challenge);
 
    opName = "Retrieve Registration Information";
    opDesc = "Retrieving Registration Information";
    finishOp(opName, opDesc, progress, "onRegisterDone");
}

function updateRegistrationInfo(challenge, memberId, password)
{
    if (memberId != null) {
        memberId.replace(/^\s+|\s+$/, '');
        password = (memberId == '') ? '' : password;
    }
    var progress = ec.register(challenge, memberId, password);
 
    opName = "Update Registration Information";
    opDesc = "Updating Registration Information";
    finishOp(opName, opDesc, progress, "onRegisterDone");
}

function performPendingTransfer(challenge)
{
    var progress = ec.transfer(challenge);
 
    opName = "Transfer";
    opDesc = "Transfering account and tickets from other device";
    finishOp(opName, opDesc, progress, "onRegisterDone");
}

function getTransferInfo(challenge)
{
    var progress = ec.transfer(challenge);
 
    opName = "Retrieve Transfer Information";
    opDesc = "Retrieving Transfer Information";
    finishOp(opName, opDesc, progress, "onRegisterDone");
}

function unregister(challenge)
{
    var progress = ec.unregister(challenge);
 
    opName = "Unregister";
    opDesc = "Unregistering";
    finishOp(opName, opDesc, progress, "onUnregisterDone");
}
       
function termsAgreed(nextPage)
{
    if (nextPage == null || nextPage == '') {
        showRegister(null, null, "W_01.jsp");
    } else {
        showPage(nextPage);
    }
}

function isParentalControlOn(age)
{
    var r = ec.getDeviceInfo ();
    if (typeof(r) == "object") {
    	if (r.isParentalControlEnabled) {
      	    if (r.userAge == null) {
      	        return false;
      	    } else if (age == null) {
    	        return true;
    	    } else {
      	        return age < userAge;
      	    }
    	} else {
            return false;
    	}
    } else {
    	return false;
    }    
}

function isParentalControlPointsOn()
{
    var r = ec.getDeviceInfo ();
    if (typeof(r) == "object") {
    	if (r.netContentRestrictions & SC_NET_CONTENT_RESTRICTION_MASK_SHOPPING) {
      	    return true;
    	} else {
            return false;
    	}
    } else {
    	return false;
    }    
}

function showParentalControlledPage(url, replace)
{
    var parentalControlOn = isParentalControlOn();
    if (parentalControlOn) {
        // Parental control is on - goto parental control page
        showPage("L_04.jsp?next=" + escape(url), replace);
    } else {
        // Parental control is off
        showPage(url, replace);
    }   
}

function checkParentalControlPassword(password)
{
    var r = ec.checkParentalControlPassword (password);
    if (typeof(r) != "boolean") {
        if (r == EC_ERROR_NOT_FOUND) {
            trace("Parental control password is not set");
            return true;
        } else {
            trace("Could not check Parental Control Password");
            return false;
        }
    } else {
        return r;
    }
}
        
// Returns if there is a title update available       
function isTitleUpdateAvailable(titleInfo, latestVersion)
{
    if (typeof(titleInfo) == "object") {
        if (titleInfo.isTmdPresent && latestVersion != null) {
            trace("Title " + titleInfo.titleId + " latest version is " 
                  + latestVersion + ", current version is " + titleInfo.version);
            return (latestVersion > titleInfo.version);
        } else {
            return false;
        } 
    } else {
        return null;
    }
}        

function isTitleOnDevice(titleInfo)
{
    if (typeof(titleInfo) == "object") {
        return titleInfo.isOnDevice;
    } else {
        return null;
    }
}

function getSecureUrl(page)
{
    if (isRelativePath(page)) {
	return secureOssPath + page;
    } else {
	return page;
    }
}

// Returns number of user bytes needed for title
// If there is an update available or the title is not owned
//  then use the title size from the catalog
// Otherwise, the title has been partially downloaded
//  get the remaining size needed from the eclib
function getFsSizeNeeded(titleInfo, catalogTitleSize, latestVersion)
{
    var spaceNeeded = catalogTitleSize;
    if (isTitleUpdateAvailable(titleInfo, latestVersion)) {
        // Update available - use catalog titleSize for space needed
    } else if (typeof(titleInfo) == "object") {
        // No update available - title partly on card
        // get size needed from eclib
        if (titleInfo.isOnDevice) {
            spaceNeeded = 0;
        } else if (titleInfo.isTmdPresent) {
            //spaceNeeded = titleInfo.sizeToDownload;
        }       
    }
    return spaceNeeded;
}
 
// Returns size to download
// If there is an update available or the title is not owned
//  then use the title size from the catalog
// Otherwise, the title has been partially downloaded
//  get the remaining size to download from the eclib
function getSizeToDownload(titleInfo, catalogTitleSize, latestVersion)
{
    var spaceNeeded = catalogTitleSize;
    if (isTitleUpdateAvailable(titleInfo, latestVersion)) {
        // Update available - use catalog titleSize for space needed
    } else if (typeof(titleInfo) == "object") {
        // No update available - title partly on card
        // get size to download from eclib
        if (titleInfo.isTmdPresent) {
            spaceNeeded = titleInfo.sizeToDownload;
        }        
    }
    return spaceNeeded;
}

// Picks a ticket to launch for title        
function getLaunchTicket(titleId)
{
    var tickets = ec.getTicketInfos (titleId);
    var limitedTicket = null;
    if (typeof(tickets) == "object") {
        var n;
        for (n = 0;  n < tickets.length; n++) {
            var ticket = tickets.get(n);
            if (ticket.limits == null || ticket.limits.length == 0) {
                return ticket;
            } else {
                limitedTicket = ticket;
            }               
        }
    } 
        
    return limitedTicket;
}

// Returns whether we have a limited or unlimited ticket for title
function getTitleLicense(titleId)
{
    // See if we have an unlimited license for the title
    var tickets = ec.getTicketInfos (titleId);
    var hasLimitedTicket = false;
    if (typeof(tickets) == "object") {
        var n;
        for (n = 0;  n < tickets.length; n++) {
            var ticket = tickets.get(n);
            if (ticket.limits == null || ticket.limits.length == 0) {
                return "Unlimited"
            } else {
                hasLimitedTicket = true;
            }               
        }
    } 
        
    if (hasLimitedTicket) {
        return "Limited";
    } else {
        return null;
    }       
}        
        
function getBalance()
{
    if (wii) {
        return ec.getCachedBalance();
    } else {
        return 1000;
    }
}

function initCommonFields(commonFieldsId)
{
    // Common hidden fields for a form
    var commonFields = document.getElementById(commonFieldsId);
    if (commonFields == null) {
        return;
    }

    var r = ec.getDeviceInfo ();
    if (typeof(r) == "object") {    
        var str = '';
        if (r.accountId != null) {
            str = str + '<input type="hidden" name="accountId" value="' + escape(r.accountId) + '"/>';
        }
        if (r.deviceId != null) {
            str = str + '<input type="hidden" name="deviceId" value="' + escape(r.deviceId) + '"/>';
        }
        if (r.serial != null) {
            str = str + '<input type="hidden" name="serialNo" value="' + escape(r.serial) + '"/>';
        }
        if (r.country != null) {
            str = str + '<input type="hidden" name="country" value="' + escape(r.country) + '"/>';
        }
        if (r.region != null) {
            str = str + '<input type="hidden" name="region" value="' + escape(r.region) + '"/>';
        }
        if (r.userAge != null) {
            str = str + '<input type="hidden" name="age" value="' + escape(r.userAge) + '"/>';
        }
        if (r.language != null) {
            str = str + '<input type="hidden" name="language" value="' + escape(r.language) + '"/>';
        }
        commonFields.innerHTML = str;
    } else {
        commonFields.innerHTML = 'error getting device info<BR>';
    }
}

function setLogUrl(url)
{
    if (shop != null) {
        try {
           url = addCommonParams(url);
           shop.getLogUrl = getSecureUrl(url);
        } catch (err) {
        }
    }
}

function postLog(info)
{
    if (info != null) {
	var form;
        form = document.getElementById("LogForm");
        if (form == null) {
            form = document.createElement("form");
            form.action = getSecureUrl("SaveLog.jsp");
            form.method = "post";
            form.id="LogForm";
            document.body.appendChild(form);
        }
    
        var formHTML = "";
        formHTML += '<div id="SaveLog.commonFields"></div>';
        formHTML += '<input type="hidden" name="log" value="' + encodeURIComponent(info) + '"/>';
        form.innerHTML = formHTML;
        initCommonFields("SaveLog.commonFields");
     
        form.submit();
    }
}

// Returns the number of titles downloaded in this session
function getTitlesDownloaded()
{
    var nTitlesDownloaded = null;
    if (ecSupportsSession()) {
        nTitlesDownloaded = ec.getSessionValue("nTitlesDownloaded");
    }
    var n = 0;
    if (nTitlesDownloaded != null) {
    	n = parseInt(nTitlesDownloaded);
    } 
    trace("Downloaded " + n + " titles");
    return n;
}

// Update the number of titles downloaded in this session
function incTitlesDownloaded()
{
    if (ecSupportsSession()) {
        var n = getTitlesDownloaded();
        n = n + 1;
        ec.setSessionValue("nTitlesDownloaded", n.toString());
        trace("Updated downloaded titles to " + n + " titles");
    }
}

// Returns the title to use for F_01 pages
function getF01Title()
{
    if (ecSupportsSession()) {
    	return ec.getSessionValue("F_01.title");
    } else {
    	return null;
    }
}

// Set the title to use for F_01 pages
function setF01Title(title)
{
    if (ecSupportsSession()) {
    	ec.setSessionValue("F_01.title", title);
    }
}

function init()
{
    var s = navigator.userAgent.toLowerCase();
    wii = s.indexOf('wii shop channel/1.0') + 1;
    opera = s.indexOf('opera') + 1;
    msie = false;
    if (!opera) {
        msie = s.indexOf('msie') + 1;
        wii = false;
    } else if (!wii) {
        wii = s.indexOf('uatest') + 1;
    }
    if (wii) {
        debug = true;
    } else {
        debug = false;
    }
}
				
		

		
